VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsKachalka"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'  hWnd -    (  ),
'   hWnd     -
Event Authenticate(hWnd As Long, Username As String, Password As String)
'   
Event Complete(ByVal Status As kach_tlb.BINDSTATUS, ByVal StatusText As String)
'  :  
'   Cancel,   
Event Progress(ByVal Progress As Long, ByVal ProgressMax As Long, ByVal Status As Long, ByVal StatusText As String, Cancel As Boolean)
'     push mode,   
' DataFormat   FORMATETC
Event DataAvailable(ByVal EventType As kach_tlb.BSCF, ByVal Data As String, ByVal DataFormat As Long)
'   ,   BINDF_RESYNCHRONIZE Or BINDF_GETFROMCACHE_IF_NET_FAIL
Event GetOptions(Options As kach_tlb.BINDF)

Event Request(ByVal Headers As String)
Event Response(ByVal Status As Long, ByVal Headers As String)

' : GET, POST,  PUT
Public Method As kach_tlb.BINDVERB
'    POST  PUT
Public RequestData As String
Public Headers As String

Implements IBindStatusCallback
Implements IAuthenticate
Implements IHttpNegotiate

Private Offset As Long
Private ReturnCode(11) As Byte

Private Declare Function GetDesktopWindow Lib "user32" () As Long

Private Sub IAuthenticate_Authenticate(hWnd As Long, pszUsername As Long, pszPassword As Long)
Dim Username As String, Password As String
    hWnd = GetDesktopWindow
    RaiseEvent Authenticate(hWnd, Username, Password)
    If hWnd = 0 Then
        pszUsername = StrPtr(Username)
        PutMem4 ByVal VarPtr(Username), 0
        pszPassword = StrPtr(Password)
        PutMem4 ByVal VarPtr(Password), 0
    End If
End Sub

Private Sub IBindStatusCallback_GetBindInfo(grfBINDF As kach_tlb.BINDF, pbindinfo As kach_tlb.BINDINFO)
    grfBINDF = BINDF_RESYNCHRONIZE Or BINDF_GETFROMCACHE_IF_NET_FAIL
    RaiseEvent GetOptions(grfBINDF)
    pbindinfo.dwBindVerb = Me.Method
    If StrPtr(Me.RequestData) Then
        pbindinfo.stgmedData.TYMED = TYMED_ISTREAM
        Set pbindinfo.stgmedData.pstm = CreateStreamOnHGlobal(0, 1)
        pbindinfo.cbstgmedData = Len(Me.RequestData)
        pbindinfo.stgmedData.pstm.Write Me.RequestData, pbindinfo.cbstgmedData
        pbindinfo.stgmedData.pstm.Seek 0, STREAM_SEEK_SET
    End If
End Sub

Private Function IBindStatusCallback_GetPriority() As Long
Stop '  
End Function

Private Sub IBindStatusCallback_OnDataAvailable(ByVal grfBSCF As kach_tlb.BSCF, ByVal dwSize As Long, pformatetc As kach_tlb.FORMATETC, pstgmed As kach_tlb.STGMEDIUM)
    dwSize = dwSize - Offset
Dim buf As String: buf = String(dwSize, 0)
    If pstgmed.TYMED <> TYMED_ISTREAM Then Error 13
    If dwSize <> pstgmed.pstm.Read(buf, dwSize) Then Error 7
    RaiseEvent DataAvailable(grfBSCF, buf, VarPtr(pformatetc))
    Offset = Offset + dwSize
End Sub

Private Sub IBindStatusCallback_OnLowResource(ByVal reserved As Long)
' 
End Sub

Private Sub IBindStatusCallback_OnObjectAvailable(riid As kach_tlb.UUID, ByVal pUnk As stdole.IUnknown)
' 
End Sub

Private Sub IBindStatusCallback_OnProgress(ByVal ulProgress As Long, ByVal ulProgressMax As Long, ByVal ulStatusCode As kach_tlb.BINDSTATUS, ByVal szStatusText As Long)
Dim Cancel As Boolean
RaiseEvent Progress(ulProgress, ulProgressMax, ulStatusCode, SysAllocString(szStatusText), Cancel)
If Cancel Then 'whoo-hoo
    Dim RetAddr As Long, pRetAddr As Long
    pRetAddr = VarPtr(ulProgress) - 8
    PutMem4 ReturnCode(1), E_ABORT
    GetMem4 ByVal pRetAddr, RetAddr
    PutMem4 ByVal pRetAddr, VarPtr(ReturnCode(0))
    PutMem4 ReturnCode(6), RetAddr
End If
End Sub

Private Sub IBindStatusCallback_OnStartBinding(ByVal dwReserved As Long, ByVal pib As kach_tlb.IBinding)
Offset = 0
End Sub

Private Sub IBindStatusCallback_OnStopBinding(ByVal hrStatus As Long, ByVal szStatusText As Long)
RaiseEvent Complete(hrStatus, SysAllocString(szStatusText))
End Sub




Public Sub DownloadToFile(ByVal URL As String, ByVal FileName As String)
Dim Result As Long
    Result = URLDownloadToFile(Nothing, URL, FileName, 0, Me)
    If Result Then Err.Raise Result
End Sub

Public Function DownloadToString(ByVal URL As String) As String
Dim Result As Long, pStream As IStream
    Result = URLOpenBlockingStream(Nothing, URL, pStream, 0, Me)
    If Result Then Err.Raise Result
Dim s As STATSTG
    pStream.Stat s, STATFLAG_NONAME
    If s.cbSizeHi Then Error 7
    DownloadToString = String(s.cbSize, 0)
    If s.cbSize <> pStream.Read(DownloadToString, s.cbSize) Then Error 7
End Function

Public Sub DownloadPush(ByVal URL As String)
Dim Result As Long, pStream As IStream
    Result = URLOpenStream(Nothing, URL, 0, Me)
    If Result Then Err.Raise Result
End Sub

Private Sub Class_Initialize()
    ReturnCode(0) = &HB8
    ReturnCode(5) = &HBA
    ReturnCode(10) = &HFF
    ReturnCode(11) = &HE2
End Sub

Private Function IHttpNegotiate_BeginningTransaction(ByVal szURL As Long, ByVal szHeaders As Long, ByVal dwReserved As Long) As String
    RaiseEvent Request(SysAllocString(szHeaders))
    IHttpNegotiate_BeginningTransaction = Headers
End Function

Private Function IHttpNegotiate_OnResponse(ByVal dwResponseCode As Long, ByVal szResponseHeaders As Long, ByVal szRequestHeaders As Long) As String
    RaiseEvent Response(dwResponseCode, SysAllocString(szResponseHeaders))
    RaiseEvent Request(SysAllocString(szRequestHeaders))
    IHttpNegotiate_OnResponse = Headers
End Function
